from xdxsmi.api.node import Node
from pathlib import Path
import re, glob

from xdxsmi.api.test2 import *

class XdxGpuInfo():
    def __init__(self, index, user_index, handle) -> None:
        queryInfo = xdxml_device_query_by_out_of_band(handle)
        self.drm_index = index
        self.user_index = user_index
        #Yufei think index(id) doesn't match with handle(device address)
        # self.drm_index = index
        # #GPU realted attributes xdx_vbios
        self.name = queryInfo.name.decode('utf-8') if queryInfo.name!=None else 'N/A'
        # self.uuid = '0x' + str(queryInfo.uuid.decode('utf-8')) if queryInfo.uuid!=None else 'N/A'
        # self.minor_num = index

        try:
            self.vbios = queryInfo.vbios_version.decode('utf-8').split(' ',1)[0] if queryInfo.vbios_version!=None else 'N/A'
        except:
            self.vbios = 'N/A'

        self.fm_ver = queryInfo.fw_ver.decode('utf-8') if queryInfo.fw_ver!=None else 'N/A'
        self.pci_bdf = format(queryInfo.domain, '04x') + ':' + format(queryInfo.bus, '02x') + ':' + format(queryInfo.device, '02x') + '.' + format(queryInfo.func, '01x')
        self.domain = '0x' + format(queryInfo.domain, '04x') if self.pci_bdf!='N/A' else 'N/A'
        self.bus = '0x' + format(queryInfo.bus, '02x') if self.pci_bdf!='N/A' else 'N/A'
        self.dev = '0x' + format(queryInfo.device, '02x') if self.pci_bdf!='N/A' else 'N/A'
        self.device_id = str(hex(queryInfo.device_id))
        # self.subsystem_device = self.device['subsystem_device'] if self.device['subsystem_device']!=None else 'N/A'
        # self.primary_core_id = queryInfo.primary_core_id.decode('utf-8') if queryInfo.primary_id!=None else 'N/A'
        # self.pcie_event = queryInfo.pcie_event if queryInfo.pcie_event!=None else 'N/A'
        self.fan_spd = queryInfo.fan_speed if queryInfo.fan_speed!=None else 'N/A'
        # self.pwm1 = int(self.hwmon['pwm1']) if self.hwmon['pwm1']!=None else 'N/A'
        # self.perform_state = 'N/A'
        # self.clk_throt_reasons = 'N/A'


        # #GPU memory info
        # self.fb_free = 'N/A' if queryInfo.fb_free =='N/A' else int(int(queryInfo.fb_free) / (1024*1024))

        self.fb_total = 'N/A' if queryInfo.fb_total =='N/A' else int(int(queryInfo.fb_total))
        # self.fb_used = 'N/A' if self.fb_total=='N/A' or self.fb_free=='N/A' else int(self.fb_total - self.fb_free)

        self.temp = str(queryInfo.temp) + "\u00B0" + "C" if queryInfo.temp!=None else 'N/A'
        self.gfx_clk = str(int(queryInfo.xdx_gfx_freq)) +'MHZ' if queryInfo.xdx_gfx_freq!=None else 'N/A'

        self.volt = str(queryInfo.volt/1000) + "V" if queryInfo.volt!=None else 'N/A'
        self.current = str(queryInfo.current/1000) + "A" if queryInfo.current!=None else 'N/A'
        self.pwr = str(queryInfo.pwr/1000) + "W" if queryInfo.pwr!=None else 'N/A'
        self.chip_model = queryInfo.chip_model.decode('utf-8') if queryInfo.chip_model!=None else 'N/A'

    def __setitem__(self, name, val):
        return setattr(self, name, val)

    def __getitem__(self, name):
        return getattr(self, name)
